#include "fifo_function_queue.h"
#include "common.h"
#include "assert_lab4.h"

static void* function_queue_buffer[FUNCTION_QUEUE_DIMENSION];
static char head, tail;

void initFunctionQueue(void)
{
    head = 0;
    tail = 0;
}

char functionQueueIsEmpty(void)
{
    if(tail == head)
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

char functionQueueIsFull(void)
{
    if((tail == head+1) || ((tail == 0) && (head == FUNCTION_QUEUE_DIMENSION - 1)))
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

void addToFunctionQueue(void* value)
{
    ASSERT(functionQueueIsFull());

    function_queue_buffer[head] = value;

    if(head == FUNCTION_QUEUE_DIMENSION - 1)
    {
        head = 0;
    }
    else
    {
        head = head + 1;
    }
}

void* getFromFunctionQueue(void)
{
    ASSERT(functionQueueIsEmpty());

    void* value;
    value = function_queue_buffer[tail];

    if(tail == FUNCTION_QUEUE_DIMENSION - 1)
    {
        tail = 0;
    }
    else
    {
        tail = tail + 1;
    }

    return value;
}
